// --------------------------------------------------------------------------------------------------------------------
// <copyright file="Dimension.cs" company="Reimers.dk">
//   Copyright © Reimers.dk 2006
// </copyright>
// <summary>
//   Defines the Dimension type.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace Reimers.Google.Analytics
{
    /// <summary>
    /// Enumeration of analysis dimensions.
    /// </summary>
    public enum Dimension
    {
        browser = 0,
        browserVersion = 1,
        city = 2,
        connectionSpeed = 3,
        continent = 4,
        countOfVisits = 5,
        country = 6,
        date = 7,
        day = 8,
        daysSinceLastVisit = 9,
        flashVersion = 10,
        hostname = 11,
        hour = 12,
        javaEnabled = 13,
        language = 14,
        latitude = 15,
        longitude = 16,
        month = 17,
        networkDomain = 18,
        networkLocation = 19,
        pageDepth = 20,
        operatingSystem = 21,
        operatingSystemVersion = 22,
        region = 23,
        screenColors = 24,
        screenResolution = 25,
        subContinent = 25,
        userDefinedValue = 26,
        visitorType = 26,
        week = 27,
        year = 28,
        adContent = 29,
        adGroup = 30,
        adSlot = 31,
        adSlotPosition = 32,
        campaign = 33,
        keyword = 34,
        medium = 35,
        referralPath = 36,
        source = 37,
        exitPagePath = 38,
        landingPagePath = 39,
        pagePath = 40,
        pageTitle = 41,
        affiliation = 42,
        daysToTransaction = 43,
        productCategory = 44,
        productName = 45,
        productSku = 46,
        transactionId = 47,
        searchCategory = 48,
        searchDestinationPage = 49,
        searchKeyword = 50,
        searchKeywordRefinement = 51,
        searchStartPage = 52,
        searchUsed = 53,
        customVarValue1 = 54,
        customVarValue2 = 55,
        customVarValue3 = 56,
        customVarValue4 = 57,
        customVarValue5 = 58
    }
}
